class iaas::profile::neutron::common (
  $public_interface = $iaas::params::public_interface,
  $admin_interface = $iaas::params::admin_interface,

  $core_plugin = $iaas::role::controller::neutron_core_plugin,
  $service_plugins = $iaas::role::controller::neutron_service_plugins,
  $external_device2 = $iaas::params::external_device2,

##verbose, debug
  $verbose = $iaas::params::verbose,
  $debug = $iaas::params::debug,

  $region = $iaas::params::region,

##rhosts
#  $endpoint = hiera('iaas::main_address', undef),
  $rhosts = $iaas::params::rhosts,
  $rabbitmq_user = $iaas::params::user,
  $rabbitmq_password = $iaas::params::password,
) {

  file { 'etc_default_neutron-server':
    path => '/etc/default/neutron-server',
    ensure => 'present'
  }

  class { '::neutron':
##added verbose, debug
    verbose => $verbose,
    debug => $debug,
    bind_host => $::facts["ipaddress_${admin_interface}"],
    core_plugin => $core_plugin,
    allow_overlapping_ips => true,
##rabbit_hosts - uncomment as needed
#    rabbit_host => $endpoint,
    rabbit_hosts => $rhosts,
    rabbit_user => $rabbitmq_user,
    rabbit_password => $rabbitmq_password,
    service_plugins => $service_plugins,
    dhcp_agents_per_network => 2
  }

  if $external_device2 {
    $network_vlan_ranges='physnet1,physnet2'
  } else {
    $network_vlan_ranges='physnet1'
  }

  class  { '::neutron::plugins::ml2':
    type_drivers => ['gre', 'flat'],
    tenant_network_types => ['gre'],
    mechanism_drivers => ['openvswitch'],
#double_external_network, variable commented
#    flat_networks => ["external"],
    tunnel_id_ranges => ['10:1000'],
#double_external_network, variable added
    network_vlan_ranges => [$network_vlan_ranges],
  }
}

